SinOsc vinny => JCRev revvy => LPF low1 => Pan2 panny => dac;
SinOsc vinny2 => Pan2 panny2 => dac;
SinOsc vinny3 => dac;
SndBuf sampler1 => JCRev revvy2 => HPF high1 => dac;
SndBuf sampler2 => dac;

0 => revvy.mix;
0.3 => revvy.gain;
0 => revvy2.mix;
0.3 => revvy2.gain;
440 => low1.freq;
0.6 => low1.Q;
440 => high1.freq;
0.6 => high1.Q;
0.1 => vinny.gain;
0.1 => vinny2.gain;
0.1 => vinny3.gain;
sampler1.read("snare.wav");
0.6 => sampler1.gain;
sampler2.read("note.wav");
0.6 => sampler2.gain;


//MESSAGING CODE DO NOT DISTURB:
OscRecv recv;
7000 => recv.port;
recv.listen();
recv.event("/params/stream, i i i") @=> OscEvent oe;
int streamNum;
int param1;
int param2;
// infinite event loop
while ( true )
{
    oe => now;
    while ( oe.nextMsg() != 0 )
    {
        oe.getInt() => streamNum;
        oe.getInt() => param1;
        oe.getInt() => param2;
        //if (oe.nextMsg() == 0)
        {
            if (streamNum==0)
                change1(param1,param2);
            if (streamNum==1)
                change2(param1,param2);
            if (streamNum==2)
                change3(param1,param2);
            if (streamNum==3)
                change4(param1,param2);
            if (streamNum==4)
                change5(param1,param2);
            if (streamNum==5)
                change6(param1,param2);
            if (streamNum==6)
                change7(param1,param2);
            if (streamNum==7)
                change8(param1,param2);
            if (streamNum==-1)
                0.0 => dac.gain;
            else
                0.5 => dac.gain;
        }
    }
}
//END OF MESSAGING CODE

//sinosc1
fun void change1(int p, int f)
{
    (320-f)+220 => vinny.freq;
    -1+(p)/160.0 => panny.pan;
}

//sinosc2
fun void change2(int a, int b)
{
    (320-b)+220 => vinny2.freq;
    -1+(a)/160.0 => panny2.pan;
}

//sinosc3
fun void change3(int a, int b)
{
    (320-b)+220 => vinny3.freq;
}

//sampler1
fun void change4(int a, int b)
{
    if (b>160)
        0 => sampler1.pos;
    0.5+(a)/320.0 => sampler1.rate;
}

//sampler2
fun void change5(int a, int b)
{
    if (b>160)
        0 => sampler2.pos;
    0.5+(a)/320.0 => sampler2.rate;
}

//reverb
fun void change6(int a, int b)
{
    -a/320.0 => revvy.mix;
    -b/960.0 => revvy.gain;
    -a/320.0 => revvy2.mix;
    -b/960.0 => revvy2.gain;
}

//lowpass
fun void change7(int a, int b)
{
    -a/320.0 => low1.Q;
    (320-b)+220 => low1.freq;
}

//highpass
fun void change8(int a, int b)
{
    -a/320.0 => high1.Q;
    (320-b)+220 => high1.freq;
}